package cs636.pizza.dao;
// Example JUnit5 test 
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;

import java.sql.SQLException;

public class MenuDAOTest {
	private DbDAO db;
	private MenuDAO menuDAO;
	
	// This executes before *each* test, so every test starts out the same way
	@BeforeEach
	public void setUp() throws Exception {
		// we use H2, the DbDAO default db, as the db for testing
		// Note: need to load it first
		db = new DbDAO(null, null, null);
		db.initializeDb();  // no orders, toppings, sizes
		menuDAO = new MenuDAO(db);
		System.out.println("created menuDAO: " + menuDAO);
	}

	@AfterEach
	public void tearDown() throws Exception {
		db.close();
	}
	
	@Test
	public void testCreateTopping() throws SQLException
	{
		menuDAO.createMenuTopping("anchovies");	
		int count = menuDAO.findMenuToppings().size();
		Assertions.assertTrue(count == 1, () -> "first topping not created");
	}
	
	@Test
	public void testCreateSize() throws SQLException
	{
		menuDAO.createMenuSize("huge");	
		int count = menuDAO.findMenuSizes().size();
		Assertions.assertTrue(count == 1, () -> "first topping not created");
	}

}
